#include "internal.h"
#include "lion/ICC_Client.h"
#include "lion/log/log.h"
#include "lion/rtos/RTOS_Sleep.h"
#include <errno.h>
#include <fcntl.h>
#include <pthread.h>
#include <string.h>
#include <sys/ioctl.h>
#include <termios.h>
#include <unistd.h>

LOG_MODULE_DECLARE(app, LOG_LEVEL_DBG);

ICC_Context_t        APP_strICC;
ICC_Client_Context_t app_strICCClient;
static pthread_t        app_icc_strThread;
static volatile bool    app_icc_bolKeepRunning = true;

void *app_icc_Entry(void *arg)
{
    (void)arg;

    while (app_icc_bolKeepRunning)
    {
        ICC_Process(&APP_strICC);
        RTOS_Sleep(RTOS_MSEC(10));
    }

    return NULL;
}

void APP_ICC_Init()
{
    ICC_Init(&APP_strICC);
    ICC_Client_Init(&app_strICCClient, &APP_strICC, "/var/run/lion-icc.sock");
};

int APP_ICC_Start()
{
    ICC_Client_Start(&app_strICCClient);
    app_icc_bolKeepRunning = true;
    pthread_create(&app_icc_strThread, NULL, app_icc_Entry, NULL);
    return ICC_Client_WaitForConnected(&app_strICCClient, RTOS_SECONDS(3));
};

void APP_ICC_Stop()
{
    app_icc_bolKeepRunning = false;
    pthread_join(app_icc_strThread, NULL);
    ICC_Client_Stop(&app_strICCClient);
};