#ifndef LION_MCUMGR_MCUMGR_H__
#define LION_MCUMGR_MCUMGR_H__

/* ======================================================================= */
/* =========================== I N C L U D E S =========================== */
/* ======================================================================= */

#include "zcbor_encode.h"
#include <stddef.h>
#include <stdint.h>

#ifdef __cplusplus
extern "C"
{
#endif

    /* ======================================================================= */
    /* ============================= D E F I N E S =========================== */
    /* ======================================================================= */

#define MCUMGR_OP_u8READ      ((uint8_t)0)
#define MCUMGR_OP_u8READ_RSP  ((uint8_t)1)
#define MCUMGR_OP_u8WRITE     ((uint8_t)2)
#define MCUMGR_OP_u8WRITE_RSP ((uint8_t)3)

#define MCUMGR_IMAGE_u16GROUP      ((uint16_t)1)
#define MCUMGR_IMAGE_u8ID_STATE    ((uint8_t)0)
#define MCUMGR_IMAGE_u8ID_UPLOAD   ((uint8_t)1)
#define MCUMGR_IMAGE_u8ID_FILE     ((uint8_t)2)
#define MCUMGR_IMAGE_u8ID_CORELIST ((uint8_t)3)
#define MCUMGR_IMAGE_u8ID_CORELOAD ((uint8_t)4)
#define MCUMGR_IMAGE_u8ID_ERASE    ((uint8_t)5)

#define MCUMGR_OS_u16GROUP            ((uint16_t)0)
#define MCUMGR_OS_u8ID_ECHO           ((uint8_t)0)
#define MCUMGR_OS_u8ID_CONS_ECHO_CTRL ((uint8_t)1)
#define MCUMGR_OS_u8ID_TASKSTAT       ((uint8_t)2)
#define MCUMGR_OS_u8ID_MPSTAT         ((uint8_t)3)
#define MCUMGR_OS_u8ID_DATETIME_STR   ((uint8_t)4)
#define MCUMGR_OS_u8ID_RESET          ((uint8_t)5)
#define MCUMGR_OS_u8ID_MCUMGR_PARAMS  ((uint8_t)6)
#define MCUMGR_OS_u8ID_INFO           ((uint8_t)7)

    /* ======================================================================= */
    /* ============================ T Y P E D E F S ========================== */
    /* ======================================================================= */

    struct MCUMGR_Header_t
    {
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
        uint8_t nh_op : 3; /* MGMT_OP_[...] */
        uint8_t res1  : 5;
#endif
#if __BYTE_ORDER__ == __ORDER_BIG_ENDIAN__
        uint8_t res1  : 5;
        uint8_t nh_op : 3; /* MGMT_OP_[...] */
#endif
        uint8_t  nh_flags; /* Reserved for future flags */
        uint16_t nh_len;   /* Length of the payload */
        uint16_t nh_group; /* MGMT_GROUP_ID_[...] */
        uint8_t  nh_seq;   /* Sequence number */
        uint8_t  nh_id;    /* Message ID within group */
    };
    typedef struct MCUMGR_Header_t MCUMGR_Header_t;

    /* ======================================================================= */
    /* ========================== P R O T O T Y P E S ======================== */
    /* ======================================================================= */

#ifdef __cplusplus
}
#endif

#endif /* LION_MCUMGR_MCUMGR_H__ */