#ifndef LION_RTOS_SLEEP_H__
#define LION_RTOS_SLEEP_H__

/* ======================================================================= */
/* =========================== I N C L U D E S =========================== */
/* ======================================================================= */

// #include <stddef.h>
// #include <stdint.h>
#include "RTOS_Timeout.h"

#ifdef __cplusplus
extern "C"
{
#endif

    /* ======================================================================= */
    /* ============================ T Y P E D E F S ========================== */
    /* ======================================================================= */

#ifdef __ZEPHYR__

    #include <zephyr/kernel.h>

    static inline void RTOS_Sleep(RTOS_Timeout_t strTimeout) { k_sleep(strTimeout); }

#elif __unix__

    #include <errno.h>
    #include <semaphore.h>
    #include <stdint.h>

static inline void RTOS_Sleep(RTOS_Timeout_t strTimeout)
{
    struct timespec strTime = RTOS_TimeoutToTimespec(strTimeout);
    clock_nanosleep(CLOCK_REALTIME, TIMER_ABSTIME, &strTime, NULL);
}

#endif

    /* ======================================================================= */
    /* ============================= D E F I N E S =========================== */
    /* ======================================================================= */

    /* ======================================================================= */
    /* ========================== P R O T O T Y P E S ======================== */
    /* ======================================================================= */

#ifdef __cplusplus
}
#endif

#endif /* LION_RTOS_SLEEP_H__ */